////////////
// COMMON //
////////////

function showHidePopupMenu() {	
	var itemId = arguments[0];
	var itemsArray = arguments;
	hideOtherItems(arguments);
	if (document.getElementById(itemId)) {		
		if (document.getElementById(itemId).style.display != 'inline') {
			// show
			document.getElementById('dimoverlay').style.visibility = 'visible';
			document.getElementById(itemId).style.display = 'inline';
			document.getElementById('dimoverlay').onclick = function(){ showHidePopupMenu.apply(this, itemsArray) };
		}else {
			// hide
			document.getElementById(itemId).style.display = 'none';
			document.getElementById('dimoverlay').style.visibility = 'hidden';
			document.getElementById('dimoverlay').onclick = null;
		}
	}
}

// WARNING: hides only items after the first one
function hideOtherItems(itemsArray){
	for (var i = 1; i < itemsArray.length; i++) {
		if (document.getElementById(itemsArray[i])) {
			document.getElementById(itemsArray[i]).style.display = 'none';
		}
	}
}

function beforeSubmitCheckbox(){
	for (var i = 0; i < arguments.length; i++) {
		var hiddenId = arguments[i] + "Hidden";
		if(document.getElementById(arguments[i]).checked){
			  document.getElementById(hiddenId).disabled = true;
		}	
	}
}

//////////////////
// BOOK DETAILS //
//////////////////

function loadBookDetails(itemId, rootPath){	
	var xmlhttp;

	document.getElementById('bookdetails').innerHTML="<div id=\"progressbar\"></div>";
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function(){	
		if (xmlhttp.readyState==4 && xmlhttp.status==200){
	    	document.getElementById('bookdetails').innerHTML=xmlhttp.responseText;
	    }
	}
	xmlhttp.open("GET", rootPath + "bookdetails/" + itemId ,true);
	xmlhttp.send();
}

///////////////////
// COMIC DETAILS //
///////////////////

function loadComicDetails(itemId, rootPath){	
	var xmlhttp;

	document.getElementById('comicdetails').innerHTML="<div id=\"progressbar\"></div>";
	xmlhttp=new XMLHttpRequest();
	xmlhttp.onreadystatechange=function(){	
		if (xmlhttp.readyState==4 && xmlhttp.status==200){
	    	document.getElementById('comicdetails').innerHTML=xmlhttp.responseText;
	    }
	}
	xmlhttp.open("GET", rootPath + "comicdetails/" + itemId ,true);
	xmlhttp.send();
}

//////////////////
// COMIC READER //
//////////////////

var currentPage = 0;
var documentId = -1;
var nbPages = -1;
var scaleImg = false;
var cookiePrefix = 'unknown';
var readerSubUrl = 'unknown';

function loadDoc(docutype, rootPath){

	cookiePrefix = docutype;
	readerSubUrl = rootPath + docutype + "reader/";
	
	documentId = document.getElementById('documentId').innerHTML;	
	nbPages = parseInt(document.getElementById('nbPages').innerHTML);
	
	// get current page from cookie
	var cookiePage = getCookie(cookiePrefix + documentId);
	if(cookiePage != '' && !isNaN(cookiePage)){
		var newPage = parseInt(cookiePage);
		if(newPage < nbPages){
			currentPage = newPage;
		}
	}
	
	document.onkeydown = handleKey;
	loadDocPage();
}

function getCookie(name) {
	var parts = document.cookie.split(name + "=");
	if (parts.length == 2){
		return parts.pop().split(";").shift();
 	}
}

function loadDocPage(){
	var targetWidth = window.innerWidth * window.devicePixelRatio - 30; // -30 for the scrollbar
	// have a min target width of 1200, as hdpi devices lie and provide much lower size than the real one
	targetWidth = Math.max(1200, targetWidth); 	
	document.getElementById('pageContent').innerHTML="<img id=displayedpage src=\"" + readerSubUrl + documentId + "?page=" + currentPage + "&width=" + targetWidth + "\">";
	scroll(0,0);
	document.getElementById('currentpage').innerHTML = currentPage + 1;
	
	// preload
	var pageToPreload = currentPage + 1;
	preload(readerSubUrl + documentId + "?page=" + pageToPreload + "&width=" + targetWidth);
	
	// set cookie (or delete it if last page is reached)
	if(currentPage == nbPages - 1){
		document.cookie = cookiePrefix + documentId + '=; expires=Thu, 01-Jan-70 00:00:01 GMT;';	
	}else{
		var exdate = new Date();
		exdate.setDate(exdate.getDate() + 365);	
		document.cookie = cookiePrefix + documentId + "=" + currentPage + "; expires=" + exdate.toUTCString();
	}
}

function preload(imgurl){
	var img = new Image(); 
	img.src = imgurl;
}

function nextPage(){	
	if(currentPage < nbPages - 1){
		currentPage++;		
		loadDocPage();	
	}
}

function previousPage(){
	if(currentPage > 0){
		currentPage--;		
		loadDocPage();
	}
}

function showHideMenu(){
	var omElts = document.getElementsByClassName('overlaymenu');
	var shown = false;
	for (var i = 0; i < omElts.length; ++i) {
		var item = omElts[i];  
	    
	   	if (item.style.display != 'inline') {
			item.style.display = 'inline';
			shown = true;			
		}else {			
			item.style.display = 'none';			
		}    
	}
	if(shown){
		document.getElementById('targetpage').focus();
	}else{
		document.getElementById('targetpage').blur();	
	}
}

function jumpToPage(){
	var targetPage = document.getElementById('targetpage').value;
	document.getElementById('targetpage').value = '';

	if(!isNaN(targetPage) && targetPage > 0){
		if(targetPage <= nbPages){
			currentPage = targetPage -1;
		}else{
			currentPage = nbPages - 1; 
		}
		loadDocPage();	
	}
}

function fitToWidth(activate){
	if(activate){
		if(!scaleImg){
			document.getElementById('displayedpage').style.width='100%';
		}
	}else{
		if(scaleImg){
			document.getElementById('displayedpage').style.width='';
		}
	}
}

function handleKey(event){	
	var charCode = (event.which) ? event.which : event.keyCode
	if(charCode == 37){
		previousPage();
	}else if(charCode == 39){
		nextPage();
	}else if(charCode == 27){
		history.back();
	}else if(charCode == 13){		
		showHideMenu();
	}
}
